package com.johnnyweb.stockWatcher.controller;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.security.access.annotation.Secured;
import org.springframework.security.crypto.codec.Base64;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.johnnyweb.interceptor.AuthenticationInterceptor;
import com.johnnyweb.stockWatcher.model.StockPrice;

@Controller
@RequestMapping("/stockWatcher")
public class JSONController {
	private static final double MAX_PRICE = 100.0; // $100.00
	private static final double MAX_PRICE_CHANGE = 0.02; // +/- 2%
	 private static final Logger logger = LoggerFactory.getLogger(JSONController.class);
  	

	@RequestMapping(method = RequestMethod.GET)
	@Secured("ROLE_ADMIN")
	public @ResponseBody List<StockPrice> getStocks( @RequestParam(value = "q", required = false) final String q ) {
		 logger.info(" getStocks is called")	;
		String[] stockSymbols = q.split(" ");
		ArrayList<StockPrice> stockPriceList= new ArrayList<StockPrice>();
		    for (String stockSymbol : stockSymbols) {
		     Random rnd = new Random();
		      double price = rnd.nextDouble() * MAX_PRICE;
		      double change = price * MAX_PRICE_CHANGE * (rnd.nextDouble() * 2f - 1f);
		      StockPrice stockPrice = new StockPrice();
			  stockPrice.setSymbol(stockSymbol);		
			  stockPrice.setPrice(price);
			  stockPrice.setChange(change);
			  stockPriceList.add(stockPrice);		   
		    }
		
		 logger.info(" getStocks is over")	;
		return stockPriceList;

	}
	

	
	public @ResponseBody List<StockPrice> getStocksForCust( @RequestParam(value = "q", required = false) final String q ) {
		 logger.info(" getStocks is called called")	;
		String[] stockSymbols = q.split(" ");
		ArrayList<StockPrice> stockPriceList= new ArrayList<StockPrice>();
		    for (String stockSymbol : stockSymbols) {
		     Random rnd = new Random();
		      double price = rnd.nextDouble() * MAX_PRICE;
		      double change = price * MAX_PRICE_CHANGE * (rnd.nextDouble() * 2f - 1f);
		      StockPrice stockPrice = new StockPrice();
			  stockPrice.setSymbol(stockSymbol);		
			  stockPrice.setPrice(price);
			  stockPrice.setChange(change);
			  stockPriceList.add(stockPrice);		   
		    }
		
		 logger.info(" getStocks is over over")	;
		return stockPriceList;

	}
	
	
	
	@RequestMapping(method = RequestMethod.POST)
	public  @ResponseBody List<StockPrice> addStock( @RequestBody StockPrice sp ) {
			
		
		String sb= sp.getSymbol();
		
		sp.getPrice();
		String q="NT";
		String[] stockSymbols = q.split(" ");
		ArrayList<StockPrice> stockPriceList= new ArrayList<StockPrice>();
		    for (String stockSymbol : stockSymbols) {
		     Random rnd = new Random();
		      double price = rnd.nextDouble() * MAX_PRICE;
		      double change = price * MAX_PRICE_CHANGE * (rnd.nextDouble() * 2f - 1f);
		      StockPrice stockPrice = new StockPrice();
			  stockPrice.setSymbol(stockSymbol);		
			  stockPrice.setPrice(price);
			  stockPrice.setChange(change);
			  stockPriceList.add(stockPrice);		   
		    }
		
		
		return stockPriceList;

	}
	
}



//@RequestMapping(value="{name}", method = RequestMethod.GET)
//public @ResponseBody List<StockPrice> getStocks(@PathVariable String name, @RequestParam(value = "q", required = false) final String q ) {
